/*
 * Stepper.h
 *
 *  Created on: Mar 6, 2012
 *      Author: B40150
 */

#ifndef MC_H_
#define MC_H_


/*******************************************************************************
* Includes
********************************************************************************/

#include "derivative.h"

/*******************************************************************************
* Types
********************************************************************************/

	typedef struct{
		UINT32	dummy;
		UINT16	pos;
		UINT16	desPos;
		UINT8   dir;
		UINT8   stopped;
		UINT8 	speed;    
		UINT16  ptrA;                                      
		UINT16  ptrB;
		UINT8	rtz;
	  }MOTOR;      

/*******************************************************************************
* Global Functions
********************************************************************************/
void MC_Init(void);
void Move_Stepper(void);
UINT8 MC_StepperStopped(UINT8 idx);
UINT16 MC_GetMotorPosition(UINT8 idx);
void MC_SetMotorPosition(UINT8 idx, UINT16 dp);
void MC_SetMotorSpeed(UINT8 idx, UINT8 s);

#endif /* MC_H_ */
